;; Problem 39
;; 14 March 2003

;; If p is the perimeter of a right angle triangle with integral length sides, {a,b,c}, there are exactly three solutions for p = 120.

;; {20,48,52}, {24,45,51}, {30,40,50}

;; For which value of p 1000, is the number of solutions maximised?

(defun find-triples (max-len)
  (let ((triples (list)))
    (loop for side-a from 1 to (- max-len 2)
	  do
	  (loop for side-b from 1 to (- max-len 2)
		do
		(let ((side-c (- max-len side-a side-b)))
		  (when (= (* side-c side-c)
			   (+ (* side-a side-a)
			      (* side-b side-b)))
		    (push (list side-a side-b side-c) triples)))))
    triples))

(defun uniq-triples-list (triples)
  (let ((ht (make-hash-table :test #'equal))
	(res (list)))
    (loop for trip in triples
	  do
	  (setf trip (sort trip #'<))
	  (when (not (gethash trip ht))
	    (setf (gethash trip ht) t)
	    (push trip res)))
    res))

; (uniq-triples-list (find-triples 120))

(let ((max-permiter 0)
      (max-count 0))
  (loop for permiter from 3 to 1000
	do
	(let ((triples (find-triples permiter)))
	  (when (> (length triples) max-count)
	    (setf max-permiter permiter)
	    (setf max-count (length triples))
	    (format t "new max permiter:~a count:~a~&"
		    permiter
		    (length triples))))))

;; 840

